using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Linq;
using NestedHtmlWriter;
using MagSiteLib;

namespace MagSite
{
    public partial class Admin : System.Web.UI.Page
    {
        private void writeCommonKeywordDeletingWarn(NhInline inline)
        {
            inline.WriteText("[̃L[[h̍폜@\͌ݎgpł܂]");
        }

        private void writeTopMenu(NhBlock block, FullKeyword keyword)
        {
            using (NhHx h1 = block.CreateHx(1))
            {
                h1.WriteText("y");
                WriteLib.WriteKeyword(h1, keyword, FileNames.Admin, User.Identity.Name);
                h1.WriteText("z̊Ǘy[W");
            }

            using (NhP p = block.CreateP())
            {
                p.WriteText("[");
                using (NhA a = p.CreateA())
                {
                    WriteLib.WriteHrefAttr(a, keyword, FileNames.AdminWrite);
                    a.WriteText("̃L[[hɐVRecǉ");
                }
                p.WriteText("]");
            }
        }

        private void writeContentsListSub(FullKeyword keyword, NhQuickDocument doc, IEnumerable<ItemID> list, string title)
        {
            SectionDef def = SectionDefManager.GetSectionDef(keyword);
            doc.B.WriteHxText(2, title);

            using (NhTable table = doc.B.CreateTable())
            {
                using (NhTr tr = table.CreateTr())
                {
                    //using( NhThInline th = tr.CreateThInline() )
                    //{
                    //	th.WriteText( "ID" );
                    //}
                    using (NhThInline th = tr.CreateThInline())
                    {
                        th.WriteText("t");
                    }
                    using (NhThInline th = tr.CreateThInline())
                    {
                        th.WriteText("^Cg");
                    }
                    using (NhThInline th = tr.CreateThInline())
                    {
                        th.WriteText("ҏW");
                    }
                    using (NhThInline th = tr.CreateThInline())
                    {
                        th.WriteText("L[[h");
                    }
                    using (NhThInline th = tr.CreateThInline())
                    {
                        th.WriteText("gbNobN");
                    }
                    using (NhThInline th = tr.CreateThInline())
                    {
                        th.WriteText("폜");
                    }
                }
                foreach (var itemID in list)
                {
                    DateTime itemDateOnly = itemID.GetDateOnly();
                    Item item = GeneralContentsHandler.GetItem(itemID);

                    using (NhTr tr = table.CreateTr())
                    {
                        //using( NhTdInline td = tr.CreateTdInline() )
                        //{
                        //	td.WriteText( item.ItemID.ToString() );
                        //}
                        using (NhTdInline td = tr.CreateTdInline())
                        {
                            if (itemID.IsDraftItemID())
                            {
                                td.WriteText(DraftManager.GetItemTimeStamp(itemID).ToString("yyyyNMMdd"));
                            }
                            else
                            {
                                td.WriteText(itemDateOnly.ToString("yyyyNMMdd"));
                            }
                        }
                        using (NhTdInline td = tr.CreateTdInline())
                        {
                            if (itemID.IsDraftItemID())
                            {
                                if (item.SubjectFull.Trim().Length == 0)
                                {
                                    td.WriteText("(^Cg)");
                                }
                                else
                                {
                                    td.WriteText(item.SubjectFull);
                                }
                            }
                            else
                            {
                                td.WriteAText(FileNames.Content + "?id=" + HttpUtility.UrlEncode(item.ItemID.ToString()),
                                    item.SubjectFull);
                            }
                        }
                        using (NhTdInline td = tr.CreateTdInline())
                        {
                            td.WriteAText(FileNames.AdminWrite + "?id=" + HttpUtility.UrlEncode(itemID.ToString()),
                                "ҏW");
                        }
                        using (NhTdInline td = tr.CreateTdInline())
                        {
                            td.WriteAText(FileNames.AdminFn + "?fn=kwrep&id=" + HttpUtility.UrlEncode(itemID.ToString()),
                                "ւ");
                        }
                        using (NhTdInline td = tr.CreateTdInline())
                        {
                            if (TrackBackRecordManager.GetRecords(item.ItemID).Length > 0)
                            {
                                td.WriteAText(FileNames.AdminFn + "?fn=tblist&id=" + HttpUtility.UrlEncode(item.ItemID.ToString()),
                                    "Xg");
                            }
                            else
                            {
                                td.WriteText("(M)");
                            }
                        }
                        using (NhTdInline td = tr.CreateTdInline())
                        {
                            td.WriteAText(FileNames.AdminFn + "?fn=delcontconf&id=" + HttpUtility.UrlEncode(item.ItemID.ToString()),
                                "폜");
                        }
                    }
                }
            }
        }

        private void writeDraftContentsList(FullKeyword keyword, NhQuickDocument doc)
        {
            DraftManager.HouseKeep();
            ItemID[] list = DraftManager.GetList(keyword);
            if (list.Length == 0) return;
            writeContentsListSub(keyword, doc, list, "̃L[[h̍쐬Recꗗ");
        }

        private void writeContentsList(FullKeyword keyword, NhQuickDocument doc)
        {
            IEnumerable<ItemID> list = ContentFileAccessLayer.EnumerateContentEntries(keyword).Select(c => c.ID);
            if (list.FirstOrDefault().ID == null) return;
            writeContentsListSub(keyword, doc, list, "̃L[[h̃Recꗗ");
        }

        private void writeFunctionsForThisKeyword(NhBlock block, FullKeyword keyword)
        {
            block.WriteHxText(2, "̃L[[hւ̑");

            using (NhP p = block.CreateP())
            {
                p.WriteText("[");
                using (NhA a = p.CreateA())
                {
                    WriteLib.WriteHrefAttr(a, keyword, FileNames.AdminEditDef);
                    a.WriteText("̃L[[h̕\JX^}CY");
                }
                p.WriteText("]");
            }

            using (NhP p = block.CreateP())
            {
                if (keyword.IsRootKeyword())
                {
                    writeCommonKeywordDeletingWarn(p);
                    p.WriteText(" ŏʃL[[h͍폜ł܂B");
                }
                else if (!General.IsTerminalKeyword(keyword))
                {
                    writeCommonKeywordDeletingWarn(p);
                    p.WriteText(" qL[[hL[[h͍폜ł܂B");
                    p.WriteText("Ƃ΁AABƂL[[hƂAA폜ɂ́AB폜Kv܂B");
                }
                else if (!GeneralContentsHandler.IsNoItemKeyword(keyword))
                {
                    writeCommonKeywordDeletingWarn(p);
                    p.WriteText(" Rec܂܂L[[h폜邱Ƃ͂ł܂B");
                    p.WriteText("Recɂ́A쐬̃htgRec܂݂܂B");
                    p.WriteText("̃L[[h폜ɂ́Aɂ̃L[[hɑRec폜ĉB");
                }
                else
                {
                    p.WriteText("[");
                    using (NhA a = p.CreateA())
                    {
                        WriteLib.WriteHrefAttr(a, keyword, ItemID.NoItem, FileNames.AdminFn, "delkwconf");
                        a.WriteText("̃L[[h폜");
                    }
                    p.WriteText("]");
                }
            }
        }

        private void writeNewKeywordForm(NhBlock block, FullKeyword keyword)
        {
            using (NhForm form = block.CreateForm(FileNames.AdminFn))
            {
                form.WriteGetMethod();
                form.WriteHxText(3, "VʃL[[h̒ǉ");
                using (NhP p = form.CreateP())
                {
                    p.WriteText("VʃL[[h");
                    using (NhInput oldKeywordInput = p.CreateInput())
                    {
                        oldKeywordInput.WriteAttribute("type", "hidden");
                        oldKeywordInput.WriteAttribute("name", "fn");
                        oldKeywordInput.WriteAttribute("value", "addkw");
                    }
                    using (NhInput oldKeywordInput = p.CreateInput())
                    {
                        oldKeywordInput.WriteAttribute("type", "hidden");
                        oldKeywordInput.WriteAttribute("name", "kw");
                        oldKeywordInput.WriteAttribute("value", keyword.EncodedKeyword);
                    }
                    using (NhInput newKeywordInput = p.CreateInput())
                    {
                        newKeywordInput.WriteAttribute("type", "text");
                        newKeywordInput.WriteAttribute("name", "new");
                        newKeywordInput.WriteAttribute("value", "");
                    }
                    p.WriteBr();
                    p.WriteText(" URLŎgZO(pAt@xbg)");
                    using (NhInput newKeywordInput = p.CreateInput())
                    {
                        newKeywordInput.WriteAttribute("type", "text");
                        newKeywordInput.WriteAttribute("name", "sk");
                        newKeywordInput.WriteAttribute("value", ShortKeywordFinder.GetNewShortKeyword());
                    }
                    using (NhInput submitButton = p.CreateInput())
                    {
                        submitButton.WriteAttribute("type", "submit");
                        submitButton.WriteAttribute("value", "ǉs");
                    }
                }
            }
        }

        private void writeSpecialAdmins(NhBlock block, FullKeyword keyword)
        {
            block.WriteHxText(2, "ȊǗp");
            using (NhP p = block.CreateP())
            {
                p.WriteText("[");
                p.WriteAText(FileNames.AdminFn + "?fn=fillShortKW", "ZOo^ĂȂSẴL[[hɂĒZO蓖Ă");
                p.WriteText("]");
            }
            using (NhP p = block.CreateP())
            {
                p.WriteText("[");
                p.WriteAText(FileNames.AdminFn + "?fn=reCreateCat", "JeS̃CfNXSʓIɍč쐬");
                p.WriteText("]");
            }
        }

        private void writeChangeMasterIDForm(NhBlock block)
        {
            block.WriteHxText(3, "}X^[ID̕ύX");
            using (NhForm form = block.CreateForm(FileNames.AdminFn))
            {
                form.WriteGetMethod();
                using (NhP p = form.CreateP())
                {
                    p.WriteText("ύX}X^[ID");
                    using (NhInput oldKeywordInput = p.CreateInput())
                    {
                        oldKeywordInput.WriteAttribute("type", "hidden");
                        oldKeywordInput.WriteAttribute("name", "fn");
                        oldKeywordInput.WriteAttribute("value", "changemasteridconf");
                    }
                    using (NhInput newKeywordInput = p.CreateInput())
                    {
                        newKeywordInput.WriteAttribute("type", "text");
                        newKeywordInput.WriteAttribute("name", "new");
                        newKeywordInput.WriteAttribute("value", "");
                    }
                    using (NhInput submitButton = p.CreateInput())
                    {
                        submitButton.WriteAttribute("type", "submit");
                        submitButton.WriteAttribute("value", "ύXs");
                    }
                }
            }
            block.WritePText("@}X^[ID́A}X^[̔F؂̑ΏۂƂȂIDłBʂ̏ݗpIDƂ͈قȂ̂łB");
            block.WritePText("@F؉\ID̒A1IDw肵ĂB");
            block.WritePText("@! }X^[ID𑶍݂ȂIDɕύX邱Ƃł܂B"
                + "̏ꍇA}X^[IDŔF؂邱Ƃs\ɂȂ܂B"
                + "ύX͐TdɍsĂBIDݒ肵ꍇ̉񕜂̎菇́Areadme.txtQƂĂB");
        }

        private void writeGeneralIDTableForUpperKeywords(NhBlock block, FullKeyword keyword)
        {
            // ũL[[hvƏʃL[[hɓIDꍇA
            // ʃL[[hIDLɂȂ߂ɁApass-1ł͂̃L[[hID
            // ÃL[[hID͏o͂Ȃ̂ŁApass-2ŏĂ

            // pass-1
            if (keyword.IsNoKeyword()) return;
            Hashtable idList = new Hashtable();
            FullKeyword kw = keyword;
            while (true)
            {
                if (kw.IsNoKeyword()) break;
                SectionDef def = SectionDefManager.GetSectionDef(kw);
                foreach (string id in def.GetRawSectionDef().GeneralAuthrizationIDs)
                {
                    bool found = false;
                    foreach (string idInList in idList.Keys)
                    {
                        if (id.ToLower() == idInList.ToLower())
                        {
                            found = true;
                            break;
                        }
                    }
                    if (!found)
                    {
                        idList.Add(id, kw);
                    }
                }
                kw = kw.GetParentKeyword();
            }

            // pass-2
            foreach (string id in ((Hashtable)(idList.Clone())).Keys)
            {
                if (keyword.CompareTo(idList[id]) == 0)
                {
                    idList.Remove(id);
                }
            }

            // pass-3
            if (idList.Count > 0)
            {
                block.WriteHxText(3, "̃L[[hǗłʃC^[ID (ʃL[[h)");

                using (NhTable table = block.CreateTable())
                {
                    using (NhTr tr = table.CreateTr())
                    {
                        using (NhThInline th = tr.CreateThInline())
                        {
                            th.WriteText("ID");
                        }
                        using (NhThInline th = tr.CreateThInline())
                        {
                            th.WriteText("IDo^ĂL[[h");
                        }
                    }
                    foreach (string id in idList.Keys)
                    {
                        using (NhTr tr = table.CreateTr())
                        {
                            using (NhTdInline td = tr.CreateTdInline())
                            {
                                td.WriteText(id);
                            }
                            using (NhTdInline td = tr.CreateTdInline())
                            {
                                td.WriteText("y");
                                WriteLib.WriteKeyword(td, (FullKeyword)idList[id], FileNames.Admin, User.Identity.Name);
                                td.WriteText("z");
                            }
                        }
                    }
                }
            }
        }

        private void writeGeneralIDTableForThisKeyword(NhBlock block, FullKeyword keyword)
        {
            SectionDef def = SectionDefManager.GetSectionDef(keyword);

            ArrayList list = (ArrayList)def.GetRawSectionDef().GeneralAuthrizationIDs.Clone();
            if (list.Count > 0)
            {
                block.WriteHxText(3, "̃L[[hǗłʃC^[ID (̃L[[h)");
                using (NhTable table = block.CreateTable())
                {
                    using (NhTr tr = table.CreateTr())
                    {
                        using (NhThInline th = tr.CreateThInline())
                        {
                            th.WriteText("ID");
                        }
                        using (NhThInline th = tr.CreateThInline())
                        {
                            th.WriteText("폜");
                        }
                    }
                    foreach (string id in list)
                    {
                        using (NhTr tr = table.CreateTr())
                        {
                            using (NhTdInline td = tr.CreateTdInline())
                            {
                                td.WriteText(id);
                            }
                            using (NhTdInline td = tr.CreateTdInline())
                            {
                                using (NhA a = td.CreateA())
                                {
                                    WriteLib.WriteHrefAttr(a, keyword, ItemID.NoItem, FileNames.AdminFn, "delgeneralidconf", "generalid", id);
                                    a.WriteText("폜");
                                }
                            }
                        }
                    }
                }
            }
        }

        private void writeAddGeneralIDForm(NhBlock block, FullKeyword keyword)
        {
            block.WriteHxText(3, "ʃC^[ID̒ǉ");
            block.WritePText("@̃L[[hƂ̉ʃL[[hǗłʃC^[IDǉ܂B");
            using (NhForm form = block.CreateForm(FileNames.AdminFn))
            {
                form.WriteGetMethod();
                using (NhP p = form.CreateP())
                {
                    p.WriteText("ǉʃC^[ID");
                    using (NhInput oldKeywordInput = p.CreateInput())
                    {
                        oldKeywordInput.WriteAttribute("type", "hidden");
                        oldKeywordInput.WriteAttribute("name", "fn");
                        oldKeywordInput.WriteAttribute("value", "addgeneralid");
                    }
                    using (NhInput oldKeywordInput = p.CreateInput())
                    {
                        oldKeywordInput.WriteAttribute("type", "hidden");
                        oldKeywordInput.WriteAttribute("name", "kw");
                        oldKeywordInput.WriteAttribute("value", keyword.EncodedKeyword);
                    }
                    using (NhInput newKeywordInput = p.CreateInput())
                    {
                        newKeywordInput.WriteAttribute("type", "text");
                        newKeywordInput.WriteAttribute("name", "new");
                        newKeywordInput.WriteAttribute("value", "");
                    }
                    using (NhInput submitButton = p.CreateInput())
                    {
                        submitButton.WriteAttribute("type", "submit");
                        submitButton.WriteAttribute("value", "ǉs");
                    }
                }
            }
            block.WritePText("@ʃC^[ID́AʃC^[̔F؂̑ΏۂƂȂIDłBʏ̃RecݗpIDłB");
            block.WritePText("@F؉\ID̒A1IDw肵ĂB");
            block.WritePText("@! ݂ȂIDʃC^[IDƂĒǉ邱Ƃł܂B"
                + "݂ȂIDǉꍇAIDŎgp邱Ƃ͂ł܂B");
        }

        protected void Page_Load(object sender, System.EventArgs e)
        {
            Authorization.ConfirmAccessPermission(User.Identity.Name, URIQueryParser.ParseKeyword(Request.Params));

            SiteMapLib.ConfirmRobotsTxtFile(WriteLib.CreateMyUri(Request.Url, "SiteMap.aspx", ""));

            FullKeyword keyword = URIQueryParser.ParseKeyword(Request.Params);
            SectionDef def = SectionDefManager.GetSectionDef(keyword);

            string title = WriteLib.KeywordToHumanReadableString(keyword) + "Ǘy[W";
            using (NhQuickDocument doc = new MyOutputDocument(Response.Output, title, keyword))
            {
                writeTopMenu(doc.B, keyword);

                using (var p = doc.B.CreateP())
                {
                    p.WriteText("[");
                    p.WriteAText(FileNames.AdminAddBook + "?s=" + def.ShortKeyword, "̃L[[h̓菑Вǉ");
                    p.WriteText("]");
                    p.WriteText("[");
                    p.WriteAText(FileNames.AdminRemoveBook + "?s=" + def.ShortKeyword, "̃L[[h̓菑Ѝ폜");
                    p.WriteText("]");
                }
                WriteLib.WriteHorizontalLine(doc.B);
                WriteLib.WriteChildKeywordsList(keyword, doc, "̃L[[h̉ʃL[[h", FileNames.Admin, User.Identity.Name);

                writeDraftContentsList(keyword, doc);
                writeContentsList(keyword, doc);

                writeFunctionsForThisKeyword(doc.B, keyword);

                writeNewKeywordForm(doc.B, keyword);

                doc.B.WriteHxText(2, "[JASINf[^[x[X");
                using (var p = doc.B.CreateP())
                {
                    p.WriteText("[");
                    p.WriteAText("AdminEditPeru.aspx", "ҏW");
                    p.WriteText("]");
                }

                if (Authorization.HasMasterAccessPermission(User.Identity.Name))
                {
                    WriteLib.WriteHorizontalLine(doc.B);
                    doc.B.WriteHxText(2, "}X^[ID̊Ǘ@\");

                    if (keyword.IsRootKeyword())
                    {
                        writeSpecialAdmins(doc.B, keyword);
                        writeChangeMasterIDForm(doc.B);
                    }

                    writeGeneralIDTableForUpperKeywords(doc.B, keyword);
                    writeGeneralIDTableForThisKeyword(doc.B, keyword);
                    writeAddGeneralIDForm(doc.B, keyword);
                }

                WriteLib.WriteHorizontalLine(doc.B);
                using (var p = doc.B.CreateP())
                {
                    p.WriteText("[");
                    p.WriteAText(FileNames.AdminFn + "?fn=allkwrep&kw=" + HttpUtility.UrlEncode(keyword.ToString()), "̃L[[h̑SRecʂ̃L[[hɈړ");
                    p.WriteText("]");
                }
                WriteLib.WriteHorizontalLine(doc.B);
                WriteLib.WriteAdminFooter(doc.B, keyword);
            }
        }

        #region Web tH[ fUCiŐꂽR[h
        override protected void OnInit(EventArgs e)
        {
            //
            // CODEGEN: ̌ĂяóAASP.NET Web tH[ fUCiŕKvłB
            //
            InitializeComponent();
            base.OnInit(e);
        }

        /// <summary>
        /// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
        /// R[h GfB^ŕύXȂłB
        /// </summary>
        private void InitializeComponent()
        {

        }
        #endregion
    }
}

